//.b 	
//	Copyright 2003-2005 Botmeister
//	
//	File: mEAnLoader.cpp
//	
//	General Library Definitions and Routines. 
//
//.e	

#include <stdio.h>
#include <cstring.h>
#include <windows.h>
#include <winbase.h>
#include <winsvc.h>
#include <winable.h>
#include <dir.h>
#include <new.h>
#include <time.h>
#include "tools.h"

// ========================================================== 
/* Definition References

typedef struct _SECURITY_ATTRIBUTES {  
		DWORD nLength;  
		LPVOID lpSecurityDescriptor;  
		BOOL bInheritHandle;
} SECURITY_ATTRIBUTES, *PSECURITY_ATTRIBUTES;

	typedef struct _SERVICE_STATUS {
		 DWORD   dwServiceType;
		 DWORD   dwCurrentState;
		 DWORD   dwControlsAccepted;
		 DWORD   dwWin32ExitCode;
		 DWORD   dwServiceSpecificExitCode;
		 DWORD   dwCheckPoint;
		 DWORD   dwWaitHint;
	} SERVICE_STATUS, *LPSERVICE_STATUS;

	DECLARE_HANDLE(SERVICE_STATUS_HANDLE);

	// [string] 
	typedef  TCHAR __RPC_FAR *LPTSTR;

	typedef struct _SECURITY_ATTRIBUTES {
		 DWORD nLength;
		 LPVOID lpSecurityDescriptor;
		 BOOL bInheritHandle;
	} SECURITY_ATTRIBUTES, *PSECURITY_ATTRIBUTES, *LPSECURITY_ATTRIBUTES;

	typedef struct _PROCESS_INFORMATION {
		 HANDLE hProcess;
		 HANDLE hThread;
		 DWORD dwProcessId;
		 DWORD dwThreadId;
	} PROCESS_INFORMATION, *PPROCESS_INFORMATION, *LPPROCESS_INFORMATION;

	BOOL CreateProcess
	(
	  LPCTSTR lpApplicationName,
									 // pointer to name of executable module
	  LPTSTR lpCommandLine,  // pointer to command line string
	  LPSECURITY_ATTRIBUTES lpProcessAttributes,  // process security attributes
	  LPSECURITY_ATTRIBUTES lpThreadAttributes,   // thread security attributes
	  BOOL bInheritHandles,  // handle inheritance flag
	  DWORD dwCreationFlags, // creation flags
	  LPVOID lpEnvironment,  // pointer to new environment block
	  LPCTSTR lpCurrentDirectory,   // pointer to current directory name
	  LPSTARTUPINFO lpStartupInfo,  // pointer to STARTUPINFO
	  LPPROCESS_INFORMATION lpProcessInformation  // pointer to PROCESS_INFORMATION
	);

	GetModuleFileNameA
	(
		IN HMODULE hModule,
		OUT LPSTR lpFilename,
		IN DWORD nSize
    );

	typedef unsigned long DWORD;

	DWORD GetPrivateProfileString(
	  LPCTSTR lpAppch_ptrName,
	  LPCTSTR lpKeyName,
	  LPCTSTR lpDefault,
	  LPTSTR lpReturnedString,
	  DWORD nSize,
	  LPCTSTR lpFileName
	);

	typedef struct _SERVICE_TABLE_ENTRY 
	{  
		LPTSTR lpServiceName;  
		LPSERVICE_MAIN_FUNCTION lpServiceProc;
	} SERVICE_TABLE_ENTRY, *LPSERVICE_TABLE_ENTRY;

	typedef struct _STARTUPINFO 
	{  
		DWORD cb;  
		LPTSTR lpReserved;  
		LPTSTR lpDesktop;  
		LPTSTR lpTitle;  
		DWORD dwX;  
		DWORD dwY;  
		DWORD dwXSize;  
		DWORD dwYSize;  
		DWORD dwXCountChars;  
		DWORD dwYCountChars;  
		DWORD dwFillAttribute;  
		DWORD dwFlags;  
		WORD wShowWindow;  
		WORD cbReserved2;  
		LPBYTE lpReserved2;  
		HANDLE hStdInput;  
		HANDLE hStdOutput;  
		HANDLE hStdError;
} STARTUPINFO, *LPSTARTUPINFO;

*/

// ========================================================== 

const string ctxVersion = "1.2.00 build 20050213.00";
const DWORD cinBufferSize = 500;

void WINAPI fvoLoaderMain( DWORD dwArgc, LPTSTR *lpszArgv );
void WINAPI fvoLoaderHandler( DWORD pinControl );

const long cinError_ServiceAlreadyInstalled = 1073;
const long cinError_ServiceIsRunning = 1072;

const string ctxServiceName = "(mEAn) Server Loader";

const string ctxLoaderPath_DEFAULT = "c:\\";
const string ctxLoaderName = "mEAnLoader";
const string ctxLogFileExt = ".log";
const string ctxIniFileExt = ".ini";
const string ctxExeFileExt = ".exe";
const string ctxLogFileName = ctxLoaderName + ctxLogFileExt;
const string ctxIniFileName = ctxLoaderName + ctxIniFileExt;
const string ctxExeFileName = ctxLoaderName + ctxExeFileExt;
const string ctxLogFilePath_DEFAULT = ctxLoaderPath_DEFAULT + ctxLogFileName;
const string ctxIniFilePath_DEFAULT = ctxLoaderPath_DEFAULT + ctxIniFileName;
const string ctxExeFilePath_DEFAULT = ctxLoaderPath_DEFAULT + ctxExeFileName;

const DWORD cinPriority_RealTime		= REALTIME_PRIORITY_CLASS;
const DWORD cinPriority_High			= HIGH_PRIORITY_CLASS;
const DWORD cinPriority_AboveNormal = ABOVE_NORMAL_PRIORITY_CLASS;
const DWORD cinPriority_Normal		= NORMAL_PRIORITY_CLASS;
const DWORD cinPriority_BelowNormal = BELOW_NORMAL_PRIORITY_CLASS;
const DWORD cinPriority_Low			= IDLE_PRIORITY_CLASS;

const string ctxPriority_RealTime	= "real";
const string ctxPriority_High			= "high";
const string ctxPriority_AboveNormal= "above";
const string ctxPriority_Normal		= "normal";
const string ctxPriority_BelowNormal= "below";
const string ctxPriority_Low			= "low";

const DWORD cinPriority_DEFAULT			= cinPriority_Normal;
const string ctxPriority_DEFAULT			= ctxPriority_Normal;

//.begin -----------------------
// Class tclLog Definitions

	#define SHOW_TIME true
	#define HIDE_TIME false
	#define LOG_ON true
	#define LOG_OFF false

	class tclLog
	{
		public:
			string vtxFileName;
			FILE* vna_ptrLogFile; 
			time_t vlgTime;
			string vtxTimeStr;		
			bool vboFileLogging;
			tclLog( );
			~tclLog( );
			
			void fvoSetFileLogging( bool pboLog ){ vboFileLogging = pboLog; };
			bool fboFileLoggingIsOn( ){ return vboFileLogging; };
			void fvoSetFileName( string ptxFileName );
			string ftxGetTimePrefix( );
			void fvoWriteToConsole( string ptxValue, bool vboDispTime = false );
			void fvoWriteToConsole_nl( string ptxValue = "", bool vboDispTime = false );
			void fvoWriteToFile( string ptxValue, bool vboDispTime = true );
			void fvoWriteToFile_nl( string ptxValue = "", bool vboDispTime = true );
			void fvoWriteToAll( string ptxValue = "", bool vboConsole_DispTime = false, bool vboFile_DispTime = true );
			void fvoWriteToAll_nl( string ptxValue = "", bool vboConsole_DispTime = false, bool vboFile_DispTime = true );

	};  // tclLog

// Class tclLog Definitions
//.end -------------------------

//.begin -----------------------
// Class tclIni Definitions

	const string ctxHeader_GlobalSettings	= "Settings";
	const string ctxTag_ServiceName			= "ServiceName";
	const string ctxTag_NumPrcs				= "NumberOfProcesses";
	const string ctxTag_ServicePriority		= "ServicePriority";
	const string ctxTag_RestartInterval		= "RestartInterval";
	const string ctxHeader_Process			= "Process_";
	const string ctxTag_AppName				= "AppName";
	const string ctxTag_AppAlias				= "ProcessName";
	const string ctxTag_CommandLine			= "CommandLine";
	const string ctxTag_StartDir				= "StartDir";
	const string ctxTag_Priority				= "Priority";
	const string ctxTag_UserInterface		= "UserInterface";
	const string ctxTag_Window					= "Window";
	const string ctxTag_Minimize				= "Minimize";
	const string ctxTag_AutoRestart			= "AutoRestart";
	const string ctxTag_Paused					= "Paused";
	const string ctxTag_StartDelay			= "StartPause";
	const string ctxTag_StopDelay				= "StopPause";

/*
	SW_FORCEMINIMIZE
		Windows 2000/XP: Minimizes a window, even if the thread that owns the window is hung. 
		This flag should only be used when minimizing windows from a different thread.
	SW_HIDE
		Hides the window and activates another window.
	SW_MAXIMIZE
		Maximizes the specified window.
	SW_MINIMIZE
		Minimizes the specified window and activates the next top-level window in the Z order.
	SW_RESTORE
		Activates and displays the window. If the window is minimized or maximized, the system 
		restores it to its original size and position. An application should specify this flag 
		when restoring a minimized window.
	SW_SHOW
		Activates the window and displays it in its current size and position. 
	SW_SHOWDEFAULT
		Sets the show state based on the SW_ value specified in the STARTUPINFO structure 
		passed to the CreateProcess function by the program that started the application. 
	SW_SHOWMAXIMIZED
		Activates the window and displays it as a maximized window.
	SW_SHOWMINIMIZED
		Activates the window and displays it as a minimized window.
	SW_SHOWMINNOACTIVE
		Displays the window as a minimized window. This value is similar to SW_SHOWMINIMIZED, 
		except the window is not activated.
	SW_SHOWNA
		Displays the window in its current size and position. This value is similar to SW_SHOW, 
		except the window is not activated.
	SW_SHOWNOACTIVATE
		Displays a window in its most recent size and position. This value is similar to 
		SW_SHOWNORMAL, except the window is not actived.
	SW_SHOWNORMAL
		Activates and displays a window. If the window is minimized or maximized, the system 
		restores it to its original size and position. An application should specify this flag 
		when displaying the window for the first time.
*/

	const string ctxWindow_ForceMinimize		= "forceminimize";
	const string ctxWindow_Hide					= "hide";
	const string ctxWindow_Maximize				= "maximize";
	const string ctxWindow_Minimize				= "minimize";
	const string ctxWindow_Restore				= "restore";
	const string ctxWindow_Show					= "show";
	const string ctxWindow_ShowDefault			= "showdefault";
	const string ctxWindow_ShowMaximized		= "showmaximized";
	const string ctxWindow_ShowMinimized		= "showminimized";
	const string ctxWindow_ShowMinNoActive		= "showminnoactive";
	const string ctxWindow_ShowNA					= "showna";
	const string ctxWindow_ShowNoActive			= "shownoactive";
	const string ctxWindow_ShowNormal			= "shownormal";
	const string ctxWindow_DEFAULT				= ctxWindow_ShowNA;
	
	const bool cboUserInterface_DEFAULT		= true;
	const int cinRestartInterval_DEFAULT   = 1000;
	const long cinWindow_DEFAULT				= SW_SHOWNA;
	const bool cboMinimize_DEFAULT			= false;
	const bool cboAutoRestart_DEFAULT		= true;
	const bool cboPaused_DEFAULT				= false;
	const int cinStartDelay_DEFAULT        = 1000;
	const int cinStopDelay_DEFAULT         = 1000;
	
	class tclIni
	{
		public:
			string vtxFileName;
			tclIni( );
			~tclIni( );
			void fvoSetFileName( string ptxFileName );
			string ftxGetValue( string ptxHeader, string ptxKey, string ptxDefault = "" );
			string ftxGetValueToLower( string ptxHeader, string ptxKey, string ptxDefault = "" );
			int finGetValue( string ptxHeader, string ptxKey, int pinDefault = 0 );
			bool fboGetValue( string ptxHeader, string ptxKey, bool pboDefault = false );
			string vtxBuildPrcHeader( int pinIdx );
			//!! to be removed
			int finGetNumPrcs( );
			//!!
			int finGetRestartInterval( );
			DWORD finGetServicePriority( );
			string ftxGetServiceName( );
			string ftxGetPrcName( int pinIdx ); 
			string ftxGetPrcAlias( int pinIdx ); 
			string ftxGetCmdLine( int pinIdx );
			string ftxGetStartDir( int pinIdx );
			DWORD finGetPriority( int pinIdx );
			bool fboGetUserInterface( );
			DWORD finGetWindow( int pinIdx );
			bool fboGetMinimize( int pinIdx );
			bool fboGetAutoRestart( int pinIdx );
			bool fboGetPaused( int pinIdx );
			DWORD finGetStartDelay( int pinIdx );
			DWORD finGetStopDelay( int pinIdx );

	};  // tclIni

// Class tclIni Definitions
//.end -------------------------

//.begin -----------------------
// Class tclPrc Definitions

	#define FORCE true

	class tclPrc
	{
		public:
			// information related to an individual process;
			long vinPrcIdx;    // this is the process index header as specified in the INI file;
			string vtxPrcName; 
			string vtxPrcAlias;
			string vtxCmdLine;
			string vtxFullCmdLine;
			string vtxStartDir;
			DWORD vinPriority;
			DWORD vinWindow;
			PROCESS_INFORMATION vstPrcInfo;
			HWND vvo_ptrPrcWindow; // handle to process window (if found);
			STARTUPINFO vstStartUpInfo;
			DWORD vinStartDelay;
			DWORD vinStopDelay;
			bool vboPrcIsOpen;
			bool vboPrcIsDelayed;
			bool vboPrcIsPaused;
			bool vboAutoRestart;
			
			tclPrc( );
			~tclPrc( );
			bool fboHidePrc( bool pboHide );
			bool fboShowWindow( DWORD pinWindow );
			bool fboStartPrc( );
			bool fboStopPrc( bool pboForce = false );
			void fvoPausePrc( ){ vboPrcIsPaused = true; };
			void fvoResumePrc( ){ vboPrcIsPaused = false; };
			bool fboSetPrcPriority(  DWORD pinPriority );
			bool fboPrcIsRunning( );
			bool fboPrcIsDelayed( ){ return vboPrcIsDelayed; };
			bool fboPrcIsPaused( ){ return vboPrcIsPaused; };
			bool fboPrcIsOpen( ){ return vboPrcIsOpen; };
			string ftxGetPrcName( ){ return vtxPrcName; };
			string ftxGetPrcAlias( ){ return vtxPrcAlias; };
			
	}; // tclPrc

// Class tclPrc Definitions
//.end -------------------------

//.begin -----------------------
// Class tclProcList Definitions

	const int cinMaxPrcs = 127;

	class tclPrcList
	{
		public:
			// information related to a list of processes;
			
			tclPrc* vcl_ptrPrc;
			int vinNumPrcs;
			int vinRestartInterval;
			bool vboStartInProgress;
			bool vboOnHold;

			tclPrcList( );
			~tclPrcList( );
			bool fboInitPrcList( );
			int finGetNumPrcs( ) { return vinNumPrcs; };
			bool fboCreatePrcList( int pinNumPrcs );
			void fvoDeletePrcList( );
			bool fboLoadPrcList( );
			bool fboPrcIsRunning( int pinPrcIdx );
			bool fboPrcIsPaused( int pinPrcIdx );
			bool fboPrcIsDelayed( int pinPrcIdx );
			bool fboAutoRestart( int pinPrcIdx );
			bool fboStartPrc( int pinPrcIdx );
			bool fboStopPrc( int pinPrcIdx, bool pboForce = false );
			bool fboPausePrc( int pinPrcIdx );
			bool fboResumePrc( int pinPrcIdx );
			bool fboHidePrc( int pinPrcIdx, bool pboHide );
			bool fboSetPrcPriority( int pinPrcIdx, DWORD pinPriority );
			void fvoStartAllPrcs( );
			void fvoStopAllPrcs( bool pboForce = false );
			void fvoCheckAllPrcs( );
			bool fboPrcIdxIsValid( int pinPrcIdx );
			string ftxGetPrcName( int pinPrcIdx );
			string ftxGetPrcAlias( int pinPrcIdx );
			int finFindPrcIdxByAlias( string ptxPrcAlias );

	}; // tclPrcList

// Class tclProcList Definitions
//.end -------------------------

//.begin -----------------------
// Class tclService Definitions

	const string ctxCommand_SrvInstall		= "-install";
	const string ctxCommand_SrvRemove		= "-remove";
	const string ctxCommand_SrvStart			= "-start";
	const string ctxCommand_SrvStop			= "-stop";
	const string ctxCommand_SrvPause			= "-pause";
	const string ctxCommand_SrvResume		= "-resume";
	const string ctxCommand_SrvHide			= "-hide";
	const string ctxCommand_SrvShow			= "-show";

	const string ctxCommand_SrvSetP_rt	= "-real";
	const string ctxCommand_SrvSetP_hi	= "-high";
	const string ctxCommand_SrvSetP_an	= "-above";
	const string ctxCommand_SrvSetP_no	= "-normal";
	const string ctxCommand_SrvSetP_bn	= "-below";
	const string ctxCommand_SrvSetP_lo	= "-low";

/*
	const long cinCommand_PrcStart	= 0x80;
	const long cinCommand_PrcStop		= 0xA0;
	const long cinCommand_PrcPause	= 0xC0;
	const long cinCommand_PrcResume	= 0xE0;
*/
	const long cinCommand_PrcStart		= 128;
	const long cinCommand_PrcStop			= 129;
	const long cinCommand_PrcPause		= 130;
	const long cinCommand_PrcResume		= 131;
	const long cinCommand_PrcSetP_rt		= 132; // set priority to realtime
	const long cinCommand_PrcSetP_hi		= 133; // high
	const long cinCommand_PrcSetP_an		= 134; // above normal
	const long cinCommand_PrcSetP_no		= 135; // normal
	const long cinCommand_PrcSetP_bn		= 136; // below normal
	const long cinCommand_PrcSetP_lo		= 137; // low
	const long cinCommand_PrcHide			= 139; // Hide
	const long cinCommand_PrcShow			= 140; // Show

	class tclService
	{
		private:
			string vtxServiceName;
		public:
			string vtxLoaderPath; 
			string vtxLoaderExePath;
			int vinServicePriority;
			bool vboUserInterface;

			SERVICE_STATUS vstServiceStatus; 
			SERVICE_STATUS_HANDLE vna_ptrServiceStatusHandle; 
			char vch_aryGLOBAL_ServiceName[ cinBufferSize + 1 ];
			
			tclService( );
			~tclService( );

			void fvoSetServiceName( );
			string ftxGetServiceName( ){ return vtxServiceName; };
			string ftxGetLoaderPath( );
			void fvoSetLoaderPath( );
			void fvoSetPriority( );

			bool fboControlService( DWORD pinControl );
			bool fboInstallService( );
			bool fboRemoveService( );

			DWORD finStartService( );
			DWORD finStopService( );
			bool fboPauseService( ){ return fboControlService( SERVICE_CONTROL_PAUSE ); };
			bool fboResumeService( ){ return fboControlService( SERVICE_CONTROL_CONTINUE ); };

	}; // tclService

// Class tclService Definitions
//.end -------------------------

//.begin -----------------------
// Global Variable Definitions

	// WARNING: order of declaration is important;
	tclLog vclLog;
	tclIni vclIni;
	// vclPrcList must be declared after vclLog;
	tclPrcList vclPrcList;
	tclService vclService;

	SECURITY_ATTRIBUTES vstGLOBAL_SecurityAttrib =
	{ sizeof(SECURITY_ATTRIBUTES),
	  NULL,
	  true };

	SERVICE_TABLE_ENTRY vstGLOBAL_DispatchTable[ ] = 
	{ 
		{ vclService.vch_aryGLOBAL_ServiceName, fvoLoaderMain }, 
		{ NULL, NULL }
	};

// Global Variable Definitions
//.end -------------------------

//.begin -----------------------
// General Routines

	DWORD vinStrToPriority( string ptxPriority )
	{
		if ( ptxPriority == ctxPriority_RealTime )
			return cinPriority_RealTime;

		if ( ptxPriority == ctxPriority_High )
			return cinPriority_High;

		if ( ptxPriority == ctxPriority_AboveNormal )
			return cinPriority_AboveNormal;

		if ( ptxPriority == ctxPriority_Normal )
			return cinPriority_Normal;

		if ( ptxPriority == ctxPriority_BelowNormal )
			return cinPriority_BelowNormal;

		if ( ptxPriority == ctxPriority_Low )
			return cinPriority_Low;

		return cinPriority_DEFAULT;

	} // vinStrToPriority

	void WINAPI fvoLoaderMain( DWORD dwArgc, LPTSTR *lpszArgv )
	{
		//!!.begin - stops compiler warning about the above two params not being used in here.
		dwArgc;
		lpszArgv;
		//!!.end

		DWORD   vinLastError; 
		DWORD   vinSpecificError = 0xfffffff; 
		string vtxMsg;

		vclService.vstServiceStatus.dwServiceType        = SERVICE_WIN32; 
		vclService.vstServiceStatus.dwCurrentState       = SERVICE_START_PENDING; 
		vclService.vstServiceStatus.dwControlsAccepted   = SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_PAUSE_CONTINUE; 
		vclService.vstServiceStatus.dwWin32ExitCode      = 0; 
		vclService.vstServiceStatus.dwServiceSpecificExitCode = 0; 
		vclService.vstServiceStatus.dwCheckPoint         = 0; 
		vclService.vstServiceStatus.dwWaitHint           = 0; 

		vclService.vna_ptrServiceStatusHandle = RegisterServiceCtrlHandler( vclService.vch_aryGLOBAL_ServiceName, fvoLoaderHandler ); 

		if ( vclService.vna_ptrServiceStatusHandle == 0 ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + "): The service could not be registered.";
			vclLog.fvoWriteToFile_nl( vtxMsg );
			return; 
		} 
	 
	   // Initialization code goes here. 
			vclLog.fvoWriteToFile_nl( "   ServiceName = " + vclService.ftxGetServiceName( ) );
			vtxMsg = "   UserInterface = ";
			vtxMsg += vclService.vboUserInterface ? "Yes" : "No";
			vclLog.fvoWriteToFile_nl( vtxMsg );

      //	vclService.fvoSetPriority( );
			vinLastError = !vclPrcList.fboInitPrcList( );
		// vinLastError = MyServiceInitialization(argc,argv, &specificError); 
		//	vinLastError = NO_ERROR;
		// fill in later, for now return NO ERROR

		if ( vinLastError != NO_ERROR ) 
		{ 
			vclService.vstServiceStatus.dwCurrentState       = SERVICE_STOPPED; 
			vclService.vstServiceStatus.dwCheckPoint         = 0; 
			vclService.vstServiceStatus.dwWaitHint           = 0; 
			vclService.vstServiceStatus.dwWin32ExitCode      = vinLastError; 
			vclService.vstServiceStatus.dwServiceSpecificExitCode = vinSpecificError; 
			SetServiceStatus( vclService.vna_ptrServiceStatusHandle, &vclService.vstServiceStatus ); 
			return; 
		} 
		 
		 // Initialization complete - report running status 
		vclService.vstServiceStatus.dwCurrentState       = SERVICE_RUNNING; 
		vclService.vstServiceStatus.dwCheckPoint         = 0; 
		vclService.vstServiceStatus.dwWaitHint           = 0;  

		if( !SetServiceStatus( vclService.vna_ptrServiceStatusHandle, &vclService.vstServiceStatus ) ) 
		{ 
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + "): The service status could not be set.";
			vclLog.fvoWriteToFile_nl( vtxMsg );
		} 

		 // This is where the service does its work. 
 		vtxMsg = "The service is now running the main thread.";
		vclLog.fvoWriteToFile_nl( vtxMsg );

 		vtxMsg = "Attempting to start processes ...";
		vclLog.fvoWriteToFile_nl( vtxMsg );
		vclPrcList.fvoStartAllPrcs( );
		Sleep( 1000 );
		// while ( vclService.vstServiceStatus.dwCurrentState == SERVICE_RUNNING )
		while ( vclService.vstServiceStatus.dwCurrentState != SERVICE_CONTROL_STOP )
		{
			if ( vclService.vstServiceStatus.dwCurrentState == SERVICE_RUNNING )
				vclPrcList.fvoCheckAllPrcs( );
			else
				Sleep( 1000 );
		}
 
		return;

	} // fvoLoaderMain

	void WINAPI fvoLoaderHandler( DWORD pinControl )
	{
		static long vinStaticCommand = 0;
		long vinCommand;
		long vinPrcNum;
		long vinPriority; 
		string vtxMsg;
		DWORD vinLastError;

		if ( pinControl == SERVICE_CONTROL_STOP )
		{
			vclPrcList.vboOnHold = true;
			vclService.vstServiceStatus.dwWin32ExitCode = 0; 
			vclService.vstServiceStatus.dwCurrentState  = SERVICE_STOPPED; 
			vclService.vstServiceStatus.dwCheckPoint    = 0; 
			vclService.vstServiceStatus.dwWaitHint      = 0;
			while ( vclPrcList.vboStartInProgress )
			{
				Sleep( 1000 );
			}
			vclPrcList.fvoStopAllPrcs( FORCE );
			goto locSetServiceStatus;
		}

		if ( pinControl == SERVICE_CONTROL_PAUSE )
		{
			vclPrcList.vboOnHold = true;
			vclService.vstServiceStatus.dwCurrentState = SERVICE_PAUSED; 
			vtxMsg = "The service has been paused.";
			goto locSetServiceStatus;
		}

		if ( pinControl == SERVICE_CONTROL_CONTINUE )
		{
			vclPrcList.vboOnHold = false;
			vclService.vstServiceStatus.dwCurrentState = SERVICE_RUNNING; 
			vtxMsg = "The service has been resumed.";
			goto locSetServiceStatus;
		}

		if ( pinControl == SERVICE_CONTROL_INTERROGATE )
		{
			goto locSetServiceStatus;
		}

		if ( vclService.vstServiceStatus.dwCurrentState == SERVICE_STOPPED )
		{
			if ( vinStaticCommand == 0 )
			{
				vtxMsg = "The service is not running.";
			}
			goto locExit;
		}

		if ( vinStaticCommand == 0 )
		{
			vinStaticCommand = pinControl;
			goto locExit;
		}
		else
		{
			vinCommand = vinStaticCommand;
			vinStaticCommand = 0;
			vinPrcNum = pinControl - 128;
		}

		// vinCommand = pinControl & 0xE0;
		// vinPrcNum  = pinControl & 0x1F;

		// vclLog.fvoWriteToFile_nl( "Command  = " + ftxIntToString( vinCommand ) );
		// vclLog.fvoWriteToFile_nl( "PrcNum   = " + ftxIntToString( vinPrcNum ) );
		
		if ( vinCommand == cinCommand_PrcStop )
		{
			if ( !vclPrcList.fboStopPrc( vinPrcNum ) )
				vtxMsg = "The process could not be stopped.";
			goto locExit;
		}

		if ( vinCommand == cinCommand_PrcStart )
		{
			if ( !vclPrcList.fboStartPrc( vinPrcNum ) )
				vtxMsg = "The process could not be started.";
			goto locExit;
		}

		if ( vinCommand == cinCommand_PrcPause )
		{
			if ( !vclPrcList.fboPausePrc( vinPrcNum ) )
				vtxMsg = "The process could not be paused.";
			goto locExit;
		}

		if ( vinCommand == cinCommand_PrcResume )
		{
			if ( !vclPrcList.fboResumePrc( vinPrcNum ) )
				vtxMsg = "The process could not be resumed.";
			goto locExit;
		}

		if ( vinCommand == cinCommand_PrcHide )
		{
			if ( !vclPrcList.fboHidePrc( vinPrcNum, true ) )
				vtxMsg = "The process window could not be hidden.";
			goto locExit;
		}

		if ( vinCommand == cinCommand_PrcShow )
		{
			if ( !vclPrcList.fboHidePrc( vinPrcNum, false ) )
				vtxMsg = "The process window could not be shown.";
			goto locExit;
		}

		if ( vinCommand == cinCommand_PrcSetP_rt )
			vinPriority = cinPriority_RealTime;
		else
		if ( vinCommand == cinCommand_PrcSetP_hi )
			vinPriority = cinPriority_High;
		else
		if ( vinCommand == cinCommand_PrcSetP_an )
			vinPriority = cinPriority_AboveNormal;
		else
		if ( vinCommand == cinCommand_PrcSetP_no )
			vinPriority = cinPriority_Normal;
		else
		if ( vinCommand == cinCommand_PrcSetP_bn )
			vinPriority = cinPriority_BelowNormal;
		else
		if ( vinCommand == cinCommand_PrcSetP_lo )
			vinPriority = cinPriority_Low;
		else
			vinPriority = -1;
	
		if ( vinPriority != -1 )
		{
			// vclLog.fvoWriteToFile_nl( "Priority = " + ftxIntToString( vinPriority ) );
			if ( !vclPrcList.fboSetPrcPriority( vinPrcNum, vinPriority ) )
				vtxMsg = "The process priority could not be set.";
			else
				vtxMsg = "The process priority was set.";

			goto locExit;
		}

		vtxMsg = "Error: Unrecognized service control code (" + ftxLongToString( pinControl ) + ").";
		goto locExit;

	locSetServiceStatus:		
		if ( !SetServiceStatus( vclService.vna_ptrServiceStatusHandle,  &vclService.vstServiceStatus ) ) 
		{ 
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + "): The service status could not be set.";
			goto locExit;
		} 

	locExit:
		if ( !vtxMsg.empty( ) )
		{
			//vclLog.fvoWriteToFile_nl( vtxMsg );
			vclLog.fvoWriteToFile_nl( vtxMsg );
		}
		
	} // fvoLoaderHandler

DWORD vinGetProcIDFromWnd( HWND pvo_ptrHWnd )
{

	if ( pvo_ptrHWnd == NULL )
	{
		return NULL;
	}

	DWORD vinProcId;

   // Get PID for this HWnd
   GetWindowThreadProcessId( pvo_ptrHWnd, &vinProcId );

   // Return PID
   return vinProcId;

} // vinGetProcIDFromWnd

HWND fvo_ptrGetWinHandle( DWORD vinProcId ) 
{
   HWND vvo_ptrHwndTemp;

   // Grab the first window handle that Windows finds:
   vvo_ptrHwndTemp = FindWindow( NULL, NULL );

   // Loop until you find a match or there are no more window handles:
	while ( vvo_ptrHwndTemp != NULL )
	{

      // Check if no parent for this window
      if ( GetParent( vvo_ptrHwndTemp ) == NULL ) 
		{
         // Check for PID match
         if ( vinProcId == vinGetProcIDFromWnd( vvo_ptrHwndTemp ) )
			{
            // Return found handle
            return ( vvo_ptrHwndTemp );
			}
		}

      // Get the next window handle
      vvo_ptrHwndTemp = GetWindow( vvo_ptrHwndTemp, GW_HWNDNEXT );
		
		// allow other stuff to happen while we loop;
		// Sleep( 100 );

   } // end while
	
	return NULL;

} // fvo_ptrGetWinHandle

// General Routines
//.end -------------------------

//.begin -----------------------
// Class tclLog Methods

	tclLog::tclLog( )
	{
		vboFileLogging = true;
		vtxFileName = ctxLogFilePath_DEFAULT;
		vna_ptrLogFile = NULL;
	} // tclLog::tclLog

	tclLog::~tclLog( )
	{
		// fvoWriteToFile_nl( "*** Log File Closed ***\n" );
		vboFileLogging = false;
		vtxFileName = "";
		vna_ptrLogFile = NULL;
	} // tclLog::~tclLog

	void tclLog::fvoSetFileName( string ptxFileName )
	{
		vtxFileName = ptxFileName;
	} // tclLog::fvoSetFileName

	string tclLog::ftxGetTimePrefix( )
	{
		time( &vlgTime );
	   vtxTimeStr = ctime( &vlgTime );

		// remove line feed;
		int vinLength = vtxTimeStr.length( );
		if ( vinLength > 0 )
		{
			if ( vtxTimeStr[ vinLength-1 ] == '\n' )
				vtxTimeStr.resize( vinLength-1 );
		}

		return vtxTimeStr + " :: ";
	} // tclLog::ftxGetTimePrefix

	void tclLog::fvoWriteToConsole( string ptxValue, bool vboDispTime )
	{
		if ( vboDispTime )
			ptxValue = ftxGetTimePrefix( ) + ptxValue;

		printf( ptxValue.c_str( ) );

	} // tclLog::fvoWriteToConsole

	void tclLog::fvoWriteToConsole_nl( string ptxValue, bool vboDispTime )
	{
		fvoWriteToConsole( ptxValue + "\n", vboDispTime );

	} // tclLog::fvoWriteToConsole

	void tclLog::fvoWriteToFile( string ptxValue, bool vboDispTime )
	{
		if ( !vboFileLogging )
			return;

		if ( ptxValue.empty( ) )
		{
			fvoWriteToConsole( ptxValue, vboDispTime );
			return;
		}

		vna_ptrLogFile = fopen( vtxFileName.c_str( ), "a" );

		if ( vna_ptrLogFile == NULL )
		{
			fvoWriteToConsole( ptxValue, vboDispTime );
			return;
		}

		if ( vboDispTime )
			ptxValue = ftxGetTimePrefix( ) + ptxValue;

		fprintf( vna_ptrLogFile, ptxValue.c_str( ) );
		fclose( vna_ptrLogFile );

	} // tclLog::fvoWriteToFile

	void tclLog::fvoWriteToFile_nl( string ptxValue, bool vboDispTime )
	{
		fvoWriteToFile( ptxValue + "\n", vboDispTime );
	} // tclLog::fvoWriteToFile

	void tclLog::fvoWriteToAll( string ptxValue, bool vboConsole_DispTime, bool vboFile_DispTime )
	{
		fvoWriteToConsole( ptxValue, vboConsole_DispTime );
		fvoWriteToFile( ptxValue, vboFile_DispTime );
	} // tclLog::fvoWriteToAll	

	void tclLog::fvoWriteToAll_nl( string ptxValue, bool vboConsole_DispTime, bool vboFile_DispTime )
	{
		fvoWriteToAll( ptxValue + "\n", vboConsole_DispTime, vboFile_DispTime );
	} // tclLog::fvoWriteToAll_nl	

// Class tclLog Methods
//.end -------------------------

//.begin -----------------------
// Class tclIni Methods

	tclIni::tclIni( )
	{
		vtxFileName = ctxIniFilePath_DEFAULT;
	} // tclIni::tclIni

	tclIni::~tclIni( )
	{
		vtxFileName = "";
	} // tclIni::~tclIni

	void tclIni::fvoSetFileName( string ptxFileName )
	{
		vtxFileName = ptxFileName;
	} // tclIni::fvoSetFileName

	string tclIni::ftxGetValue( string ptxHeader, string ptxKey, string ptxDefault )
	{
		char vch_aryBuffer[ cinBufferSize + 1 ];
		GetPrivateProfileString( ptxHeader.c_str( ), ptxKey.c_str( ), ptxDefault.c_str( ), vch_aryBuffer, cinBufferSize, vtxFileName.c_str( ) );
		string vtxResult = vch_aryBuffer;
		vclLog.fvoWriteToFile_nl( "   " + ptxKey + " = " + vtxResult );
		if ( vtxResult.empty( ) )
		{
			vtxResult = ptxDefault;
			// vclLog.fvoWriteToFile_nl( "   Applying Default::" + ptxKey + " = " + vtxResult );
		}
		return vtxResult;
	} // tclIni::ftxGetValue

	string tclIni::ftxGetValueToLower( string ptxHeader, string ptxKey, string ptxDefault )
	{
		string vtxResult = ftxGetValue( ptxHeader, ptxKey, ptxDefault );
		return ftxToLower( vtxResult );

	} // tclIni::ftxGetValueToLower

	int tclIni::finGetValue( string ptxHeader, string ptxKey, int pinDefault )
	{
		string vtxDefault = ftxLongToString( pinDefault );
		string vtxResult = ftxGetValue( ptxHeader, ptxKey, vtxDefault );
		return finStringToInt( vtxResult );

	} // tclIni::finGetValue

	bool tclIni::fboGetValue( string ptxHeader, string ptxKey, bool pboDefault )
	{
		// E1 ? E2 : E3
		// E1 evaluates first. If its value is true, then E2 evaluates and E3 is ignored. 
		// If E1 evaluates to false, then E3 evaluates and E2 is ignored.

		string vtxDefault = pboDefault ? "yes" : "no";
		string vtxResult = ftxGetValueToLower( ptxHeader, ptxKey, vtxDefault );
		return ( vtxResult == "yes" ) ? true : false;

	} // tclIni::fboGetValue

//!!.begin - to be replaced using a loop to count how many valid process headers exist
	int tclIni::finGetNumPrcs( )
	{ 
		vclLog.fvoSetFileLogging( LOG_OFF );
		int vinIdx = 0;
		while ( ftxGetPrcName( vinIdx ) != "" )
		{
			vinIdx++;
			if ( vinIdx == cinMaxPrcs )
			{
				vclLog.fvoWriteToFile_nl( "The maximum number of processes has been reached." );
				goto locExit;
			}
		}

		// int vinNumPrcs = finGetValue( ctxHeader_GlobalSettings, ctxTag_NumPrcs, 0 );
		// if ( vinNumPrcs < 0 )
		//	vinNumPrcs = 0;
		locExit:
			vclLog.fvoSetFileLogging( LOG_ON );
			return vinIdx;

	} // tclIni::finGetNumPrcs
//!!

	DWORD tclIni::finGetServicePriority( ) 
	{ 
		string vtxPriority = ftxGetValue( ctxHeader_GlobalSettings, ctxTag_ServicePriority, ctxPriority_DEFAULT ); 
		return vinStrToPriority( vtxPriority );
	} // tclIni::finGetServicePriority

	int tclIni::finGetRestartInterval( )
	{ 
		int vinRestartInterval = finGetValue( ctxHeader_GlobalSettings, ctxTag_RestartInterval, cinRestartInterval_DEFAULT );
		if ( vinRestartInterval < 0 )
			vinRestartInterval = 0;
		return vinRestartInterval;
	} // tclIni::finGetRestartInterval

	string tclIni::ftxGetServiceName( ) 
	{ 
		string vtxServiceName = ftxGetValue( ctxHeader_GlobalSettings, ctxTag_ServiceName, ctxServiceName ); 
		//vclLog.fvoWriteToConsole_nl( "From INI = " + vtxServiceName );
		return vtxServiceName;
	} // tclIni::ftxGetServiceName

	bool tclIni::fboGetUserInterface( )
	{ 
		vclLog.fvoSetFileLogging( LOG_OFF );
		bool vboResult = 
			fboGetValue( ctxHeader_GlobalSettings, ctxTag_UserInterface, cboUserInterface_DEFAULT ); 
		vclLog.fvoSetFileLogging( LOG_ON );
		return vboResult;

	} // tclIni::fboGetUserInterface

	string tclIni::vtxBuildPrcHeader( int pinIdx )
	{
		return ctxHeader_Process + ftxLongToString( pinIdx );
	} // tclIni::vtxBuildPrcHeader

	string tclIni::ftxGetPrcName( int pinIdx ) 
	{ 
		return ftxGetValue( vtxBuildPrcHeader( pinIdx ), ctxTag_AppName ); 
	} // tclIni::ftxGetPrcName

	string tclIni::ftxGetPrcAlias( int pinIdx ) 
	{ 
		return ftxGetValue( vtxBuildPrcHeader( pinIdx ), ctxTag_AppAlias ); 
	} // tclIni::ftxGetPrcAlias

	string tclIni::ftxGetCmdLine( int pinIdx ) 
	{ 
		return ftxGetValue( vtxBuildPrcHeader( pinIdx ), ctxTag_CommandLine ); 
	} // tclIni::ftxGetCmdLine
	
	string tclIni::ftxGetStartDir( int pinIdx ) 
	{ 
		string vtxStartDir = ftxGetValue( vtxBuildPrcHeader( pinIdx ), ctxTag_StartDir ); 
		if ( vtxStartDir == "" )
		{
			vclLog.fvoSetFileLogging( LOG_OFF );
			vtxStartDir = ftxGetPrcName( pinIdx );
			vclLog.fvoSetFileLogging( LOG_ON );
			vtxStartDir = ftxExtractFilePath( vtxStartDir );
			// vclLog.fvoWriteToFile_nl( "Extracted StartDir = " + vtxStartDir );
		}
		return vtxStartDir;

	} // tclIni::ftxGetStartDir

	DWORD tclIni::finGetPriority( int pinIdx ) 
	{ 
		string vtxPriority = ftxGetValueToLower( vtxBuildPrcHeader( pinIdx ), ctxTag_Priority, ctxPriority_DEFAULT ); 
		return vinStrToPriority( vtxPriority );
	} // tclIni::finGetPriority

	DWORD tclIni::finGetWindow( int pinIdx )
	{ 
		string vtxWindow = 
			ftxGetValueToLower( vtxBuildPrcHeader( pinIdx ), ctxTag_Window, ctxWindow_DEFAULT ); 
/*		
	SW_FORCEMINIMIZE
		Windows 2000/XP: Minimizes a window, even if the thread that owns the window is hung. 
		This flag should only be used when minimizing windows from a different thread.
	SW_HIDE
		Hides the window and activates another window.
	SW_MAXIMIZE
		Maximizes the specified window.
	SW_MINIMIZE
		Minimizes the specified window and activates the next top-level window in the Z order.
	SW_RESTORE
		Activates and displays the window. If the window is minimized or maximized, the system 
		restores it to its original size and position. An application should specify this flag 
		when restoring a minimized window.
	SW_SHOW
		Activates the window and displays it in its current size and position. 
	SW_SHOWDEFAULT
		Sets the show state based on the SW_ value specified in the STARTUPINFO structure 
		passed to the CreateProcess function by the program that started the application. 
	SW_SHOWMAXIMIZED
		Activates the window and displays it as a maximized window.
	SW_SHOWMINIMIZED
		Activates the window and displays it as a minimized window.
	SW_SHOWMINNOACTIVE
		Displays the window as a minimized window. This value is similar to SW_SHOWMINIMIZED, 
		except the window is not activated.
	SW_SHOWNA
		Displays the window in its current size and position. This value is similar to SW_SHOW, 
		except the window is not activated.
	SW_SHOWNOACTIVATE
		Displays a window in its most recent size and position. This value is similar to 
		SW_SHOWNORMAL, except the window is not actived.
	SW_SHOWNORMAL
		Activates and displays a window. If the window is minimized or maximized, the system 
		restores it to its original size and position. An application should specify this flag 
		when displaying the window for the first time.
*/

		if ( vtxWindow == ctxWindow_ForceMinimize )
			return SW_FORCEMINIMIZE;
		if ( vtxWindow == ctxWindow_Hide )
			return SW_HIDE;
		if ( vtxWindow == ctxWindow_Maximize )
			return SW_MAXIMIZE;
		if ( vtxWindow == ctxWindow_Minimize )
			return SW_MINIMIZE;
		if ( vtxWindow == ctxWindow_Restore )
			return SW_RESTORE;
		if ( vtxWindow == ctxWindow_Show )
			return SW_SHOW;
		if ( vtxWindow == ctxWindow_ShowDefault )
			return SW_SHOWDEFAULT;
		if ( vtxWindow == ctxWindow_ShowMaximized )
			return SW_SHOWMAXIMIZED;
		if ( vtxWindow == ctxWindow_ShowMinimized )
			return SW_SHOWMINIMIZED;
		if ( vtxWindow == ctxWindow_ShowMinNoActive )
			return SW_SHOWMINNOACTIVE;
		if ( vtxWindow == ctxWindow_ShowNA )
			return SW_SHOWNA;
		if ( vtxWindow == ctxWindow_ShowNoActive )
			return SW_SHOWNOACTIVATE;
		if ( vtxWindow == ctxWindow_ShowNormal )
			return SW_SHOWNORMAL;

		vclLog.fvoWriteToFile_nl( "Error: Invalid Setting = " + vtxWindow );
		return cinWindow_DEFAULT;

	} // tclIni::finGetWindow

	bool tclIni::fboGetAutoRestart( int pinIdx )
	{
		return fboGetValue( vtxBuildPrcHeader( pinIdx ), ctxTag_AutoRestart, cboAutoRestart_DEFAULT ); 
	} // tclIni::fboGetAutoRestart

	bool tclIni::fboGetPaused( int pinIdx )
	{
		return fboGetValue( vtxBuildPrcHeader( pinIdx ), ctxTag_Paused, cboPaused_DEFAULT ); 
	} // tclIni::fboGetPaused

	DWORD tclIni::finGetStartDelay( int pinIdx )
	{ 
		return finGetValue( vtxBuildPrcHeader( pinIdx ), ctxTag_StartDelay, cinStartDelay_DEFAULT ); 
	} // tclIni::finGetStartDelay

	DWORD tclIni::finGetStopDelay( int pinIdx )
	{ 
		return finGetValue( vtxBuildPrcHeader( pinIdx ), ctxTag_StopDelay, cinStopDelay_DEFAULT ); 
	} // tclIni::finGetStopDelay

// Class tclIni Methods
//.end -------------------------

//.begin -----------------------
// Class tclPrc Methods

	tclPrc::tclPrc( )
	{
		vinPrcIdx					= -1;    // this is the process index header as specified in the INI file;
		vtxPrcName					= ""; 
		vtxPrcAlias					= ""; 
		vtxCmdLine					= "";
		vtxFullCmdLine				= "";
		vtxStartDir					= "";
		vinPriority					= cinPriority_Normal;
		vinWindow					= cinWindow_DEFAULT;
		vinStartDelay				= cinStartDelay_DEFAULT;
		vinStopDelay				= cinStopDelay_DEFAULT;
		vboPrcIsOpen				= false;
		vboAutoRestart				= false;
		vboPrcIsDelayed			= false;
		vboPrcIsPaused				= false;
		vstPrcInfo.dwProcessId	= -1;
		vstPrcInfo.hProcess		= NULL;
		vvo_ptrPrcWindow			= NULL;

	} // tclPrc::tclPrc

	tclPrc::~tclPrc( )
	{
		vboPrcIsOpen = false;
		vboPrcIsDelayed = false;
	} // tclPrc::~tclPrc

	bool tclPrc::fboShowWindow( DWORD pinWindow )
	{

		if ( !vboPrcIsOpen )
		{
			return false;
		}

		if ( vvo_ptrPrcWindow == NULL )
		{
			return false;
		}

		if ( vboPrcIsDelayed )
		{
			return false;
		}

		ShowWindow( vvo_ptrPrcWindow,  pinWindow );
		return true;

	} // tclPrc::fboShowWindow

	bool tclPrc::fboStartPrc( )
	{
		/*
			BOOL CreateProcess
			(
			  LPCTSTR lpApplicationName,	// pointer to name of executable module
			  LPTSTR lpCommandLine,			// pointer to command line string
			  LPSECURITY_ATTRIBUTES lpProcessAttributes,  // process security attributes
			  LPSECURITY_ATTRIBUTES lpThreadAttributes,   // thread security attributes
			  BOOL bInheritHandles,			// handle inheritance flag
			  DWORD dwCreationFlags,		// creation flags
			  LPVOID lpEnvironment,			// pointer to new environment block
			  LPCTSTR lpCurrentDirectory, // pointer to current directory name
			  LPSTARTUPINFO lpStartupInfo,// pointer to STARTUPINFO
			  LPPROCESS_INFORMATION lpProcessInformation  // pointer to PROCESS_INFORMATION
			);
			
			typedef struct _PROCESS_INFORMATION 
			{  
				HANDLE hProcess;  
				HANDLE hThread;  
				DWORD dwProcessId;  
				DWORD dwThreadId;
			} PROCESS_INFORMATION;
		*/

		/*
			long vinPrcIdx;    // this is the process index header as specified in the INI file;
			long vinPrcId;     // this is the Process Id assigned by the OS;
			string vtxPrcName; 
			string vtxCmdLine;
			string vtxStartDir;
			DWORD vinPriority;
			bool vinWindow;
			PROCESS_INFORMATION vstPrcInfo;
			STARTUPINFO vstStartUpInfo;
			DWORD vinStartDelay;
			DWORD vinStopDelay;
*/

		if ( fboPrcIsDelayed( ) )
			return false;

		if ( fboPrcIsRunning( ) )
			return false;

		DWORD vinLastError;
		string vtxMsg;

		vstStartUpInfo.cb					= sizeof( STARTUPINFO );	// DWORD cb  
		vstStartUpInfo.lpReserved		= NULL;							// LPTSTR lpReserved 
		vstStartUpInfo.lpDesktop		= NULL;							// LPTSTR lpDesktop  
		vstStartUpInfo.lpTitle			= NULL;							// LPTSTR lpTitle 
		vstStartUpInfo.dwX				= 0;								// DWORD dwX 
		vstStartUpInfo.dwY				= 0;								// DWORD dwY 
		vstStartUpInfo.dwXSize			= 0;								// DWORD dwXSize 
		vstStartUpInfo.dwYSize			= 0;								// DWORD dwYSize 
		vstStartUpInfo.dwXCountChars	= 0;								// DWORD dwXCountChars 
		vstStartUpInfo.dwYCountChars	= 0;								// DWORD dwYCountChars 
		vstStartUpInfo.dwFillAttribute= 0;								// DWORD dwFillAttribute 
		vstStartUpInfo.dwFlags			= STARTF_USESHOWWINDOW; 
//		vstStartUpInfo.dwFlags			= 0;
		vstStartUpInfo.wShowWindow		= cinWindow_DEFAULT;			// WORD wShowWindow 
		vstStartUpInfo.cbReserved2		= 0;								// WORD cbReserved2 
		vstStartUpInfo.lpReserved2		= NULL;							// LPBYTE lpReserved2 
		vstStartUpInfo.hStdInput		= NULL;							// HANDLE hStdInput 
		vstStartUpInfo.hStdOutput		= NULL;							// HANDLE hStdOutput 
		vstStartUpInfo.hStdError		= NULL;							// HANDLE hStdError 

		//vclLog.fvoWriteToFile_nl( "vinWindow = " + ftxLongToString( vinWindow ) ); 
		//vclLog.fvoWriteToFile_nl( "wShowWindow = " + ftxLongToString( vstStartUpInfo.wShowWindow ) ); 

//		if ( CreateProcess( 
//				NULL,
//				const_cast < char * >( vtxFullCmdLine.c_str( ) ), 
//				NULL, 
//				NULL,
//				TRUE,
//				vinPriority,
//				NULL,
//				const_cast < char * >( vtxStartDir.c_str( ) ),
//				&vstStartUpInfo,
//				&vstPrcInfo ) 
//			)

		if ( CreateProcess( 
				NULL,
				const_cast < char * >( vtxFullCmdLine.c_str( ) ), 
				&vstGLOBAL_SecurityAttrib, 
				&vstGLOBAL_SecurityAttrib,
				TRUE,
				vinPriority , /* CREATE_NEW_CONSOLE ? */
				NULL,
				const_cast < char * >( vtxStartDir.c_str( ) ),
				&vstStartUpInfo,
				&vstPrcInfo ) 
			)

		{
			vboPrcIsOpen = true;
			vboPrcIsDelayed = true;
			if ( vinStartDelay > 0 )
			{
				Sleep( vinStartDelay );
			}

			WaitForInputIdle( vstPrcInfo.hProcess, vinStartDelay );

			vvo_ptrPrcWindow = fvo_ptrGetWinHandle( vstPrcInfo.dwProcessId );
			vtxMsg = "Started program " + vtxPrcName;
			vboPrcIsDelayed = false;
/*
typedef struct tagGUITHREADINFO {
    DWORD cbSize;
    DWORD flags;
    HWND hwndActive;
    HWND hwndFocus;
    HWND hwndCapture;
    HWND hwndMenuOwner;
    HWND hwndMoveSize;
    HWND hwndCaret;
    RECT rcCaret;
} GUITHREADINFO, *PGUITHREADINFO
*/
/*
			if ( vinWindow == SW_SHOW )
			{
				PostThreadMessage( vstPrcInfo.dwThreadId, WM_SHOWWINDOW, true, 0 );
			}
			else
				PostThreadMessage( vstPrcInfo.dwThreadId, WM_SHOWWINDOW, false, 0 );
*/			
			if ( vinWindow == cinWindow_DEFAULT )
				goto locReturn;

			vclLog.fvoWriteToFile_nl( vtxMsg ); 
			vtxMsg = "";

// 
			if ( fboShowWindow( vinWindow ) )
				goto locReturn;

//1			if ( vvo_ptrPrcWindow != NULL )
//1			{
//1				if ( ShowWindow( vvo_ptrPrcWindow,  vinWindow ) )
//1					goto locReturn;	
//1			}

//			GUITHREADINFO vstGUIThreadInfo;
//			vstGUIThreadInfo.cbSize = sizeof( GUITHREADINFO );
//
//
//			if ( GetGUIThreadInfo( vstPrcInfo.dwThreadId, &vstGUIThreadInfo ) )
//			{
//				if ( ShowWindow( vstGUIThreadInfo.hwndActive,  vinWindow ) )
//					goto locReturn;	
//			}
		
			vtxMsg = "Warning: The window setting cannot be changed for this process.";

		locReturn:
			if ( !vtxMsg.empty( ) )
			{
				vclLog.fvoWriteToFile_nl( vtxMsg ); 
			}

			return true;
		}

		vinLastError = GetLastError( );
		vtxMsg = "Error ( " + ftxLongToString( vinLastError ) + " ): Failed to start program " + vtxPrcName;
		vclLog.fvoWriteToFile_nl( vtxMsg ); 
		return false;

	} // tclPrc::fboStartPrc

	bool tclPrc::fboStopPrc( bool pboForce ) 
	{  
		if ( !fboPrcIsRunning( ) )
			return false;

		if ( !pboForce )
		{
			if ( fboPrcIsDelayed( ) )
				return false;
		} 
		else
		{
			while ( fboPrcIsDelayed( ) )
				Sleep( 1000 );
		} 

		if ( vstPrcInfo.hProcess == NULL )
			return false;

		vboPrcIsDelayed = true;
		string vtxMsg = "Stopped process ";

		if( vinStopDelay > 0 )
		{
			//vclLog.fvoWriteToFile_nl( "About to post quit msg ..." ); 
			if ( !PostThreadMessage( vstPrcInfo.dwThreadId, WM_QUIT, 0, 0 ) )
			{
				vclLog.fvoWriteToFile_nl( "Stop failed: " + vtxPrcName ); 
			}
			else
			{
				//vclLog.fvoWriteToFile_nl( "Posted quit msg, now sleeping ..." ); 
				Sleep( vinStopDelay );
				//vclLog.fvoWriteToFile_nl( "Awake." ); 
			}
		}

		vboPrcIsDelayed = false;

		if ( fboPrcIsRunning( ) )
		{
			vtxMsg = "Terminated process ";
			//vclLog.fvoWriteToFile_nl( "Process still running, about to terminate ..." ); 
			if ( !TerminateProcess( vstPrcInfo.hProcess, 0 ) )
			{
				vclLog.fvoWriteToFile_nl( "Terminate failed: " + vtxPrcName ); 
				return false;
			}
		}

		vclLog.fvoWriteToFile( vtxMsg );
		vclLog.fvoWriteToFile_nl( vtxPrcName, HIDE_TIME ); 
		
		CloseHandle( vstPrcInfo.hProcess );
		vstPrcInfo.dwProcessId = -1;
		vstPrcInfo.hProcess = NULL;
		vboPrcIsOpen = false;
		vvo_ptrPrcWindow = NULL;
		return true;

	} // tclPrc::fboStopPrc

	bool tclPrc::fboPrcIsRunning( )
	{
/*
		 HANDLE hProcess;
		 HANDLE hThread;
		 DWORD dwProcessId;
		 DWORD dwThreadId;
*/

//		vclLog.fvoWriteToFile_nl( "Checking if Process is running: " + vtxPrcName ); 
//		vclLog.fvoWriteToFile_nl( "Process Id = " + ftxLongToString( vstPrcInfo.dwProcessId ) );
		
//		HANDLE vna_ptrProcessHandle = OpenProcess( PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, 1352 /*vstPrcInfo.dwProcessId */ );
/*
HANDLE OpenThread(
  DWORD dwDesiredAccess,
  BOOL bInheritHandle,
  DWORD dwThreadId
);

*/

//		HANDLE vna_ptrProcessHandle = OpenThread( THREAD_QUERY_INFORMATION, FALSE, vstPrcInfo.dwThreadId );

//		if ( vna_ptrProcessHandle != NULL )

		DWORD vinStatus;
		if ( GetExitCodeProcess( vstPrcInfo.hProcess, &vinStatus )  )

//		if ( GetPriorityClass( vstPrcInfo.hProcess ) != 0 )

//		if ( vna_ptrProcessHandle != NULL 
//					&&
//			  vna_ptrProcessHandle == vstPrcInfo.hProcess /* INVALID_HANDLE_VALUE */ /* NULL */ )
		{
			if ( vinStatus == STILL_ACTIVE )
			{
	//			vclLog.fvoWriteToFile_nl( "Process handle is not NULL: " + vtxPrcName ); 
	//			CloseHandle( vna_ptrProcessHandle );
				vboPrcIsOpen = true;
			}
			else
				vboPrcIsOpen = false;
		}
		else
		{
//			vclLog.fvoWriteToFile_nl( "Process handle is NULL: " + vtxPrcName ); 
			vboPrcIsOpen = false;
		}

		return vboPrcIsOpen;

	} // tclPrc::fboPrcIsRunning

	bool tclPrc::fboSetPrcPriority( DWORD pinPriority )
	{
		bool vboResult = true;
		vinPriority = pinPriority;

		HANDLE vstProcessHandle = OpenProcess( PROCESS_SET_INFORMATION, FALSE, vstPrcInfo.dwProcessId );
		
		if ( vstProcessHandle != NULL )
		{
			vboResult = SetPriorityClass( vstProcessHandle, pinPriority );
			CloseHandle( vstProcessHandle );
		}

		return vboResult;

	} // tclPrc::fboSetPrcPriority

	bool tclPrc::fboHidePrc( bool pboHide )
	{
		if ( !fboPrcIsRunning( ) ) 
			return false;

		if ( pboHide )
			return fboShowWindow( SW_HIDE );
		else
			return fboShowWindow( SW_SHOWNA );

	} // tclPrc::fboHidePrc

// Class tclPrc Methods
//.end -------------------------

//.begin -----------------------
// Class tclPrcList Methods

	tclPrcList::tclPrcList( )
	{
		vboStartInProgress = false;
		vboOnHold = false;
		vcl_ptrPrc = NULL;
		vinNumPrcs = 0;
		vinRestartInterval = cinRestartInterval_DEFAULT;

	} // tclPrcList::tclPrcList

	tclPrcList::~tclPrcList( )
	{
		fvoDeletePrcList( );
		vboStartInProgress = false;
		// vclLog.fvoWriteToFile_nl( "Process List Deallocated." );
	} // tclPrcList::tclPrcList

	void tclPrcList::fvoDeletePrcList( )
	{
		if ( vcl_ptrPrc == NULL )
			return;

		delete[] vcl_ptrPrc; 
		vcl_ptrPrc = NULL;
		vinNumPrcs = 0;

	} // tclPrcList::fvoDeletePrcList

	bool tclPrcList::fboCreatePrcList( int pinNumPrcs )
	{
		fvoDeletePrcList( );

		if ( pinNumPrcs <= 0 )
			return true;

		if ( pinNumPrcs > cinMaxPrcs ) pinNumPrcs = cinMaxPrcs;
		// change default handler to return NULL on fail;
		set_new_handler( 0 );
		vcl_ptrPrc = new tclPrc[ pinNumPrcs ];

		if ( vcl_ptrPrc == NULL )
			goto locFailed;
		
		// if we get here the argument list was successfully created with
		// element size = pinNumArgs;
		vinNumPrcs = pinNumPrcs;
		return true;

		locFailed:
		{
			vinNumPrcs = 0;
			vcl_ptrPrc = NULL;
			return false;
		}

	} // tclPrcList::fboCreatePrcList

	bool tclPrcList::fboLoadPrcList( )
	{
		for ( int vinIdx = 0; vinIdx < vinNumPrcs; vinIdx++ )
		{
			vclLog.fvoWriteToFile_nl( );
			vclLog.fvoWriteToFile_nl( "[" + vclIni.vtxBuildPrcHeader( vinIdx ) + "]" );
			vcl_ptrPrc[ vinIdx ].vtxPrcName			= vclIni.ftxGetPrcName( vinIdx );
			vcl_ptrPrc[ vinIdx ].vtxPrcAlias			= vclIni.ftxGetPrcAlias( vinIdx );
			vcl_ptrPrc[ vinIdx ].vtxCmdLine			= vclIni.ftxGetCmdLine( vinIdx );
			vcl_ptrPrc[ vinIdx ].vtxStartDir			= vclIni.ftxGetStartDir( vinIdx );
			vcl_ptrPrc[ vinIdx ].vinPriority			= vclIni.finGetPriority( vinIdx );
			vcl_ptrPrc[ vinIdx ].vinWindow			= vclIni.finGetWindow( vinIdx );
			vcl_ptrPrc[ vinIdx ].vboAutoRestart		= vclIni.fboGetAutoRestart( vinIdx );
			vcl_ptrPrc[ vinIdx ].vboPrcIsPaused		= vclIni.fboGetPaused( vinIdx );
			vcl_ptrPrc[ vinIdx ].vinStartDelay		= vclIni.finGetStartDelay( vinIdx );
			vcl_ptrPrc[ vinIdx ].vinStopDelay		= vclIni.finGetStopDelay( vinIdx );

			vcl_ptrPrc[ vinIdx ].vtxFullCmdLine = vcl_ptrPrc[ vinIdx ].vtxPrcName + " " + vcl_ptrPrc[ vinIdx ].vtxCmdLine;
		}

		return true;

	} // tclPrcList::fboLoadPrcList

	bool tclPrcList::fboInitPrcList( )
	{
		vinNumPrcs = vclIni.finGetNumPrcs( );
		vinRestartInterval = vclIni.finGetRestartInterval( );
				
		vclLog.fvoWriteToFile_nl( "Loading process values from ini file ...");
		if ( vinNumPrcs > 0 )
		{
			if ( !fboCreatePrcList( vinNumPrcs ) )
			{
				vclLog.fvoWriteToFile_nl( "Could not allocate enough memory." );
				return false;
			}

			if ( !fboLoadPrcList( ) )
			{
				vclLog.fvoWriteToFile_nl( "The process list could not be successfully loaded." );
				return false;
			}

		}

		vclLog.fvoWriteToFile_nl( );
		vclLog.fvoWriteToFile_nl( "Load completed." );

		return true;

	} // tclPrcList::fboInitPrcList

	bool tclPrcList::fboPrcIdxIsValid( int pinPrcIdx )
	{
		if ( pinPrcIdx < 0 || pinPrcIdx >= vinNumPrcs )
			return false;

		return true;

	} // tclPrcList::fboPrcIdxIsValid

	string tclPrcList::ftxGetPrcName( int pinPrcIdx )
	{
		if ( pinPrcIdx < 0 || pinPrcIdx > vinNumPrcs )
			return "";

		return vcl_ptrPrc[ pinPrcIdx ].ftxGetPrcName( );
	} // tclPrcList::ftxGetPrcName

	string tclPrcList::ftxGetPrcAlias( int pinPrcIdx )
	{
		if ( pinPrcIdx < 0 || pinPrcIdx > vinNumPrcs )
			return "";

		return vcl_ptrPrc[ pinPrcIdx ].ftxGetPrcAlias( );
	} // tclPrcList::ftxGetPrcAlias

	int tclPrcList::finFindPrcIdxByAlias( string ptxPrcAlias )
	{

//		string vtxMsg = "Searching for: " + ptxPrcAlias;
//		vclLog.fvoWriteToAll_nl( vtxMsg );

		int vinPrcIdx = -1;
		string vtxPrcAlias;

		if ( ptxPrcAlias.empty( ) )
		{
//			vtxMsg = "empty";
//			vclLog.fvoWriteToAll_nl( vtxMsg );
			goto locExit;
		}
		
		vinNumPrcs = vclIni.finGetNumPrcs( );
		vclLog.fvoSetFileLogging( LOG_OFF );

//		vtxMsg = "Number of Processes found: " + ftxIntToString( vinNumPrcs);
//		vclLog.fvoWriteToAll_nl( vtxMsg );

		for ( int vinIdx = 0; vinIdx < vinNumPrcs; vinIdx++ )
		{
			vtxPrcAlias = vclIni.ftxGetPrcAlias( vinIdx );
//			vtxMsg = "Looking at: '" + vtxPrcAlias + "' == '" + ptxPrcAlias + "'";
//			vclLog.fvoWriteToAll_nl( vtxMsg );

			if ( vtxPrcAlias == ptxPrcAlias )
			{
//				vtxMsg = "Found: " + vtxPrcAlias;
//				vclLog.fvoWriteToAll_nl( vtxMsg );
				vinPrcIdx = vinIdx;
				goto locExit;
			}
		}

		locExit:
			vclLog.fvoSetFileLogging( LOG_ON );
			return vinPrcIdx;

	} // tclPrcList::finFindPrcIdxByAlias

	bool tclPrcList::fboPrcIsRunning( int pinPrcIdx )
	{
		if ( !fboPrcIdxIsValid( pinPrcIdx ) )
			return false;

		return vcl_ptrPrc[ pinPrcIdx ].fboPrcIsRunning( );

	} // tclPrcList::fboPrcIsRunning

	bool tclPrcList::fboPrcIsPaused( int pinPrcIdx )
	{
		if ( !fboPrcIdxIsValid( pinPrcIdx ) )
			return false;
//		string vtxMsg;	
//		vtxMsg = ftxIntToString( pinPrcIdx ) + " : " + ftxIntToString( vcl_ptrPrc[ pinPrcIdx ].fboPrcIsPaused( ) );
//		vclLog.fvoWriteToFile_nl( vtxMsg ); 
		return vcl_ptrPrc[ pinPrcIdx ].fboPrcIsPaused( );

	} // tclPrcList::fboPrcIsPaused

	bool tclPrcList::fboPrcIsDelayed( int pinPrcIdx )
	{
		if ( !fboPrcIdxIsValid( pinPrcIdx ) )
			return false;

		return vcl_ptrPrc[ pinPrcIdx ].fboPrcIsDelayed( );

	} // tclPrcList::fboPrcIsDelayed

	bool tclPrcList::fboAutoRestart( int pinPrcIdx )
	{
		if ( !fboPrcIdxIsValid( pinPrcIdx ) )
			return false;

		return vcl_ptrPrc[ pinPrcIdx ].vboAutoRestart;

	} // tclPrcList::fboAutoRestart

	bool tclPrcList::fboStartPrc( int pinPrcIdx )
	{
		if ( vboOnHold )
			return false;

		if ( !fboPrcIdxIsValid( pinPrcIdx ) )
			return false;

		return vcl_ptrPrc[ pinPrcIdx ].fboStartPrc( );

	} // tclPrcList::fboStartPrc

	bool tclPrcList::fboStopPrc( int pinPrcIdx, bool pboForce )
	{
		if ( !fboPrcIdxIsValid( pinPrcIdx ) )
			return false;

		return vcl_ptrPrc[ pinPrcIdx ].fboStopPrc( pboForce );

	} // tclPrcList::fboStopPrc

	void tclPrcList::fvoStartAllPrcs( )
	{
		if ( vboOnHold )
			return;

		if ( vboStartInProgress )
			return;

		vboStartInProgress = true;
		for (	int vinPrcIdx = 0; vinPrcIdx < vinNumPrcs; vinPrcIdx++ )
		{
			if ( !vboOnHold && !fboPrcIsPaused( vinPrcIdx ) )
			// if ( !fboPrcIsPaused( vinPrcIdx ) )
				fboStartPrc( vinPrcIdx );
		}
		vboStartInProgress = false;

	} // tclPrcList::fvoStartAllPrcs

	void tclPrcList::fvoStopAllPrcs( bool pboForce )
	{
		for (	int vinPrcIdx = 0; vinPrcIdx < vinNumPrcs; vinPrcIdx++ )
		{
			// vclLog.fvoWriteToFile_nl( "Stopping proc " + ftxIntToString( vinPrcIdx ) );
			fboStopPrc( vinPrcIdx, pboForce );
		}

	} // tclPrcList::fvoStopAllPrcs
	
	bool tclPrcList::fboSetPrcPriority( int pinPrcIdx, DWORD pinPriority )
	{
		if ( !fboPrcIdxIsValid( pinPrcIdx ) )
			return false;

		return vcl_ptrPrc[ pinPrcIdx ].fboSetPrcPriority( pinPriority );

	} // tclPrcList::fboSetPrcPriority

	bool tclPrcList::fboPausePrc( int pinPrcIdx )
	{
		if ( !fboPrcIdxIsValid( pinPrcIdx ) )
			return false;

		vcl_ptrPrc[ pinPrcIdx ].fvoPausePrc( );
		return true;

	} // tclPrcList::fboPausePrc

	bool tclPrcList::fboResumePrc( int pinPrcIdx )
	{
		if ( !fboPrcIdxIsValid( pinPrcIdx ) )
			return false;

		vcl_ptrPrc[ pinPrcIdx ].fvoResumePrc( );
		return true;

	} // tclPrcList::fboResumePrc

	bool tclPrcList::fboHidePrc( int pinPrcIdx, bool pboHide )
	{
		if ( !fboPrcIdxIsValid( pinPrcIdx ) )
			return false;

		return vcl_ptrPrc[ pinPrcIdx ].fboHidePrc( pboHide );

	} // tclPrcList::fboHidePrc

	void tclPrcList::fvoCheckAllPrcs( )
	{
		if ( vinNumPrcs <= 0 )
		{
			Sleep( vinRestartInterval );
			return;
		}

		if ( vboStartInProgress )
		{
			return;
		}
		
		int vinCheckInterval = vinRestartInterval / vinNumPrcs;
		string vtxMsg;

		for (	int vinPrcIdx = 0; vinPrcIdx < vinNumPrcs; vinPrcIdx++ )
		{
			if ( fboAutoRestart( vinPrcIdx ) && !fboPrcIsPaused( vinPrcIdx ) )
			{
				if ( !fboPrcIsRunning( vinPrcIdx ) )
				{
					vtxMsg = "Process (" + ftxIntToString( vinPrcIdx ) + "): Attempting to restart program: " + ftxGetPrcName( vinPrcIdx );
					vclLog.fvoWriteToFile_nl( vtxMsg );
					if ( !fboStartPrc( vinPrcIdx ) )
					{
						vtxMsg = "The program could not be restarted at this time.";
						vclLog.fvoWriteToFile_nl( vtxMsg );
					}
				}
			}

			Sleep( vinCheckInterval );
		}
	
	} // tclPrcList::fvoCheckAllPrcs

// Class tclPrcList Methods
//.end -------------------------

//.begin -----------------------
// Class tclService Methods

	tclService::tclService( )
	{
		vtxServiceName		  = ctxServiceName;
		vtxLoaderPath		  = ctxLoaderPath_DEFAULT; 
		vtxLoaderExePath	  = ctxExeFilePath_DEFAULT;
		vinServicePriority  = cinPriority_DEFAULT;
		vboUserInterface    = cboUserInterface_DEFAULT;
		vna_ptrServiceStatusHandle = NULL; 
		// char *strcpy(char *dest, const char *src);
		strcpy( vch_aryGLOBAL_ServiceName, vtxServiceName.c_str( ) );
	} // tclService::tclService

	tclService::~tclService( )
	{
	} // tclService::~tclService

	void tclService::fvoSetServiceName( )
	{
		vclLog.fvoSetFileLogging( LOG_OFF );
		string vtxNewServiceName = vclIni.ftxGetServiceName( );
		// vclLog.fvoWriteToConsole_nl( "Service Name is '" + vtxNewServiceName + "' Default is = " + ctxServiceName);
		vclLog.fvoSetFileLogging( LOG_ON );

		if ( vtxNewServiceName.length( ) > cinBufferSize )
		{
			string vtxMsg = "Error: The service name exceeds the maximum length allowed.";
			vclLog.fvoWriteToFile_nl( vtxMsg );
			return;
		}
		vtxServiceName = vtxNewServiceName;
		strcpy( vch_aryGLOBAL_ServiceName, vtxServiceName.c_str( ) );
	
		// vclLog.fvoWriteToConsole_nl( "Service Name is '" + vtxServiceName + "' Default is = " + ctxServiceName);

	} // tclService::fvoSetServiceName

	string tclService::ftxGetLoaderPath( )
	{
		string vtxModuleFilePath = ctxLoaderPath_DEFAULT;
		char vch_ptrModuleFileName[ cinBufferSize + 1 ];
		DWORD vinSize = GetModuleFileName( NULL, vch_ptrModuleFileName, cinBufferSize );

		// ensure the string is null terminated - note: the returned string is 
		// supposed to be null terminated according to the API documentation;
		if ( vinSize < 0 || vinSize > cinBufferSize )
		{
			return vtxModuleFilePath;
		}

		vch_ptrModuleFileName[ vinSize ] = 0;

		// find first occurance of '\' character scanning backwards;
		DWORD vinIdx_Path;
		for ( vinIdx_Path = vinSize - 1; vinIdx_Path >= 0; vinIdx_Path-- )
		{
			if ( vch_ptrModuleFileName[ vinIdx_Path ] == '\\' )
			{
				goto locPathFound; 
			}
		}

		locPathFound:
		if ( vinIdx_Path >= 2 ) // minimum path size;
		{
			vtxModuleFilePath = "";
			for ( DWORD vinIdx = 0; vinIdx <= vinIdx_Path; vinIdx++ )
				vtxModuleFilePath += vch_ptrModuleFileName[ vinIdx ];
		}
		
		return vtxModuleFilePath;

	} // tclService::ftxGetLoaderPath

	void tclService::fvoSetLoaderPath( )
	{
		vtxLoaderPath = ftxGetLoaderPath( );
		vtxLoaderExePath = vtxLoaderPath + ctxExeFileName;
	} // tclService::fvoSetLoaderPath

	bool tclService::fboControlService( DWORD pinControl )
	{
		string vtxMsg = "";
		int vinLastError = 0;
		SC_HANDLE vna_ptrSCService;
		SC_HANDLE vna_ptrSCManager = OpenSCManager( NULL, NULL, SC_MANAGER_ALL_ACCESS ); 
		
		if ( vna_ptrSCManager == NULL ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + "): The service manager could not be opened.";
			vclLog.fvoWriteToAll_nl( vtxMsg );
			goto locReturnResult;
		}

		vna_ptrSCService = OpenService( vna_ptrSCManager, vtxServiceName.c_str( ), SERVICE_ALL_ACCESS );

		if ( vna_ptrSCService == NULL ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + "): The service could not be opened.";
			vclLog.fvoWriteToAll_nl( vtxMsg );
			goto locCloseManager;
		}
		
		if ( !ControlService( vna_ptrSCService, pinControl, &vstServiceStatus ) )
		{
			vinLastError = GetLastError( );
			vclLog.fvoWriteToAll_nl( "Error (" + ftxLongToString( vinLastError ) + ") The service could not execute the command." );
		}

	locCloseService:
		CloseServiceHandle( vna_ptrSCService ); 

	locCloseManager:
		CloseServiceHandle( vna_ptrSCManager );	

	locReturnResult:
		if ( vinLastError != 0 ) return false;

		return true;

	} // tclService::fboControlService

	bool tclService::fboInstallService( ) 
	{  
		long vinLastError;
		string vtxMsg = "";
		DWORD vinServiceType = SERVICE_WIN32_OWN_PROCESS;

		SC_HANDLE vna_ptrSCService;
		SC_HANDLE vna_ptrSCManager = OpenSCManager( NULL, NULL, SC_MANAGER_CREATE_SERVICE ); 
		
		if ( vna_ptrSCManager == NULL ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not open the Service Manager.";
			goto locReturnResult;
		}

		if ( vboUserInterface )
		{
			vtxMsg = "*** The service will be Interactive ***";
			vinServiceType |= SERVICE_INTERACTIVE_PROCESS;
		}
		else
			vtxMsg = "*** The service will not be interactive ***";

		vclLog.fvoWriteToConsole_nl( );
		vclLog.fvoWriteToAll_nl( vtxMsg );
		vclLog.fvoWriteToConsole_nl( );
		vtxMsg = "";

		vna_ptrSCService = CreateService
		( 
			vna_ptrSCManager,				// SCManager database      
			vtxServiceName.c_str( ),	// name of service         
			vtxServiceName.c_str( ),	// service name to display 
			SERVICE_ALL_ACCESS,			// desired access   
			vinServiceType,				// service type             
			SERVICE_AUTO_START,			// start type              
			SERVICE_ERROR_NORMAL,		// error control type    
			vtxLoaderExePath.c_str( ),	// service's binary        
			NULL,                      // no load ordering group  
			NULL,                      // no tag identifier       
			NULL,                      // no dependencies         
			NULL,                      // LocalSystem account     
			NULL								// no password    
		);                     

		if ( vna_ptrSCService == 0 ) 
		{
			vinLastError = GetLastError( );
			
			if ( vinLastError == cinError_ServiceAlreadyInstalled )
				vtxMsg = "The service is already installed.";
			else
				vtxMsg = vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not install the Service.";

			goto locCloseManager;
		}

		vclLog.fvoWriteToAll_nl( "The service " + vtxServiceName + " was successfully installed." );

	locCloseService:
		CloseServiceHandle( vna_ptrSCService ); 

	locCloseManager:
		CloseServiceHandle( vna_ptrSCManager );	

	locReturnResult:
		if ( !vtxMsg.empty( ) )
			vclLog.fvoWriteToAll_nl( vtxMsg );

		if ( vinLastError != 0 ) return false;

		return true;

	} // tclService::fboInstallService

	bool tclService::fboRemoveService( )
	{
		long vinLastError;
		string vtxMsg = "";
		SC_HANDLE vna_ptrSCService;
		SC_HANDLE vna_ptrSCManager = OpenSCManager( NULL, NULL, SC_MANAGER_ALL_ACCESS ); 

		if ( vna_ptrSCManager == NULL ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not open the Service Manager.";
			goto locReturnResult;
		}

		vna_ptrSCService = OpenService( vna_ptrSCManager, vtxServiceName.c_str( ), SERVICE_ALL_ACCESS );

		if ( vna_ptrSCService == NULL ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not open the Service.";
			goto locCloseManager;
		}

		if ( !QueryServiceStatus( vna_ptrSCService, &vstServiceStatus ) ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not query the Service.";
			goto locCloseService;
		}

		if ( vstServiceStatus.dwCurrentState != SERVICE_STOPPED )
		{
			if ( !ControlService( vna_ptrSCService, SERVICE_CONTROL_STOP, &vstServiceStatus ) )
			{
				vinLastError = GetLastError( );
				vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not stop the Service.";
				goto locCloseService;
			}
		}

		if ( !DeleteService( vna_ptrSCService ) ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not remove the service.";
			
			vtxMsg += " Reason: ";
			if ( vinLastError == cinError_ServiceIsRunning )
				vtxMsg += "The service is still running.";
			else
				vtxMsg += "See error code.";

			goto locCloseService;
		}
		
		vtxMsg = "The service " + vtxServiceName + " was successfully removed.";

	locCloseService:
		CloseServiceHandle( vna_ptrSCService ); 

	locCloseManager:
		CloseServiceHandle( vna_ptrSCManager );	
		
	locReturnResult:
		if ( !vtxMsg.empty( ) )
			vclLog.fvoWriteToAll_nl( vtxMsg );

		if ( vinLastError != 0 ) return false;

		return true;

	} // tclService::fboRemoveService

	DWORD tclService::finStartService( )
	{
		string vtxMsg;
		int vinWaitInterval;
		DWORD vinLastError;

		SC_HANDLE vna_ptrSCService;
		SC_HANDLE vna_ptrSCManager = OpenSCManager( NULL, NULL, SC_MANAGER_ALL_ACCESS ); 
		
		if ( vna_ptrSCManager == NULL )
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not open the Service Manager.";
			goto locReturnResult;
		}
		
		vna_ptrSCService = OpenService( vna_ptrSCManager, vtxServiceName.c_str( ), SERVICE_ALL_ACCESS );

		if ( vna_ptrSCService == NULL )
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not open the Service.";
			goto locCloseManager;
		}

		if ( !QueryServiceStatus( vna_ptrSCService, &vstServiceStatus ) ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not query the Service.";
			goto locCloseService;
		}

		if ( vstServiceStatus.dwCurrentState == SERVICE_RUNNING )
		{
			vtxMsg = "The service is running.";
			goto locCloseService;
		}
		else
		if ( vstServiceStatus.dwCurrentState == SERVICE_PAUSED )
		{
			vtxMsg = "The service is paused.";
			goto locCloseService;
		}

		if ( !StartService( vna_ptrSCService,  0, NULL ) )
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") The service failed to start.";
			goto locCloseService;
		} 
		
		vinWaitInterval = 0;

	locQueryStatus:
		if ( !QueryServiceStatus( vna_ptrSCService, &vstServiceStatus ) ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not open the Service Manager.";
			goto locCloseService;
		}
 
		if ( vinWaitInterval >= cinStartDelay_DEFAULT * 3 )
			goto locFinalStatus;
			
		while ( vstServiceStatus.dwCurrentState == SERVICE_START_PENDING ) 
		{
    		Sleep( cinStartDelay_DEFAULT );
			vinWaitInterval += cinStartDelay_DEFAULT;
			goto locQueryStatus;
		}

	locFinalStatus:
		if ( vstServiceStatus.dwCurrentState != SERVICE_RUNNING ) 
		{
			// failed to start within the startup time interval;
			vtxMsg = "The service failed to start within the allowed time interval.";
			vinLastError = -1;
			goto locCloseService;
		}
    
		vtxMsg = "The service was successfully started.";

	locCloseService:
		CloseServiceHandle( vna_ptrSCService ); 

	locCloseManager:
		CloseServiceHandle( vna_ptrSCManager );	
		
	locReturnResult:
		if ( !vtxMsg.empty( ) )
			vclLog.fvoWriteToAll_nl( vtxMsg );
	
		return vinLastError;

	} // tclService::finStartService

	DWORD tclService::finStopService( )
	{
		string vtxMsg = "";
		int vinWaitInterval;
		DWORD vinLastError;

		SC_HANDLE vna_ptrSCService;
		SC_HANDLE vna_ptrSCManager = OpenSCManager( NULL, NULL, SC_MANAGER_ALL_ACCESS ); 
		
		if ( vna_ptrSCManager == NULL )
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not open the Service Manager.";
			goto locReturnResult;
		}
		
		vna_ptrSCService = OpenService( vna_ptrSCManager, vtxServiceName.c_str( ), SERVICE_ALL_ACCESS );

		if ( vna_ptrSCService == NULL )
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not open the Service.";
			goto locCloseManager;
		}

		if ( !QueryServiceStatus( vna_ptrSCService, &vstServiceStatus ) ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not query the Service.";
			goto locCloseService;
		}

		if ( vstServiceStatus.dwCurrentState == SERVICE_STOPPED )
		{
			vtxMsg = "The service is not running.";
			vclLog.fvoWriteToAll_nl( vtxMsg );
			goto locCloseService;
		}

		if ( !ControlService( vna_ptrSCService, SERVICE_CONTROL_STOP, &vstServiceStatus ) )
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not control the Service.";
			goto locCloseService;
		} 
		
		vinWaitInterval = 0;

	locQueryStatus:
		if ( !QueryServiceStatus( vna_ptrSCService, &vstServiceStatus ) ) 
		{
			vinLastError = GetLastError( );
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) + ") Could not query the Service.";
			goto locCloseService;
		}
 
		if ( vinWaitInterval >= cinStartDelay_DEFAULT * 4 )
			goto locFinalStatus;
			
		while ( vstServiceStatus.dwCurrentState == SERVICE_STOP_PENDING ) 
		{
    		Sleep( cinStartDelay_DEFAULT );
			vinWaitInterval += cinStartDelay_DEFAULT;
			goto locQueryStatus;
		}

	locFinalStatus:
		if ( vstServiceStatus.dwCurrentState != SERVICE_STOPPED ) 
		{
			// failed to stop within the startup time interval;
			vinLastError = -1;
			vtxMsg = "The service failed to stop within the allowed time interval.";
			goto locCloseService;
		}
    
		vtxMsg = "The service was successfully stopped.";
		
	locCloseService:
		CloseServiceHandle( vna_ptrSCService ); 

	locCloseManager:
		CloseServiceHandle( vna_ptrSCManager );	
		
	locReturnResult:
		if ( !vtxMsg.empty( ) )
			vclLog.fvoWriteToAll_nl( vtxMsg );

		return vinLastError;

	} // tclService::finStopService

// Class tclService Methods
//.end -------------------------

void fvoDisplayUsage( )
{
	vclLog.fvoWriteToConsole_nl( "\nUsage: meanloader < command >");
	vclLog.fvoWriteToConsole_nl( );
	vclLog.fvoWriteToConsole_nl( " Service Commands");
	vclLog.fvoWriteToConsole_nl( "       -install    installs the service" );
	vclLog.fvoWriteToConsole_nl( "       -remove     removes the service" );
	vclLog.fvoWriteToConsole_nl( "       -start      starts the service" );
	vclLog.fvoWriteToConsole_nl( "       -stop       stops the service" );
	vclLog.fvoWriteToConsole_nl( "       -pause      pauses the service if running" );
	vclLog.fvoWriteToConsole_nl( "       -resume     resumes the service if paused" );
	vclLog.fvoWriteToConsole_nl( );
	vclLog.fvoWriteToConsole_nl( " Process Commands, n = process number from INI file");
	vclLog.fvoWriteToConsole_nl( "       -stop n     stops process" );
	vclLog.fvoWriteToConsole_nl( "       -start n    starts process" );
	vclLog.fvoWriteToConsole_nl( "       -pause n    pauses auto restart" );
	vclLog.fvoWriteToConsole_nl( "       -resume n   resumes auto restart" );
	vclLog.fvoWriteToConsole_nl( "       -hide n     hides process window" );
	vclLog.fvoWriteToConsole_nl( "       -show n     unhides process window" );
	vclLog.fvoWriteToConsole_nl( "       -real n     sets priority to realtime" );
	vclLog.fvoWriteToConsole_nl( "       -high n     sets priority to high" );
	vclLog.fvoWriteToConsole_nl( "       -above n    sets priority to above normal" );
	vclLog.fvoWriteToConsole_nl( "       -normal n   sets priority to normal" );
	vclLog.fvoWriteToConsole_nl( "       -below n    sets priority to below normal" );
	vclLog.fvoWriteToConsole_nl( "       -low n      sets priority to low" );
	
} // fvoDisplayUsage

bool fboExecPrcCommand( int pinCommand, string ptxPrcIdx )
{
	string vtxMsg;
	long vinCommand;
	long vinPrcNum;

	vtxMsg = "Attempting to ";
	if ( pinCommand == cinCommand_PrcStop )
		vtxMsg += "stop ";
	else
	if ( pinCommand == cinCommand_PrcStart )
		vtxMsg += "start ";
	else
	if ( pinCommand == cinCommand_PrcPause )
		vtxMsg += "pause ";
	else
	if ( pinCommand == cinCommand_PrcResume )
		vtxMsg += "resume ";
	else
	if ( pinCommand == cinCommand_PrcHide )
		vtxMsg += "hide ";
	else
	if ( pinCommand == cinCommand_PrcShow )
		vtxMsg += "show ";
	else
	if ( pinCommand == cinCommand_PrcSetP_rt )
		vtxMsg += "set priority to realtime on ";
	else
	if ( pinCommand == cinCommand_PrcSetP_hi )
		vtxMsg += "set priority to high on ";
	else
	if ( pinCommand == cinCommand_PrcSetP_an )
		vtxMsg += "set priority to above normal on ";
	else
	if ( pinCommand == cinCommand_PrcSetP_no )
		vtxMsg += "set priority to normal on ";
	else
	if ( pinCommand == cinCommand_PrcSetP_bn )
		vtxMsg += "set priority to below normal on ";
	else
	if ( pinCommand == cinCommand_PrcSetP_lo )
		vtxMsg += "set priority to low on ";
	else
	{
		vtxMsg = "Unknown command.";
		goto locReturnError;
	}
	
	vtxMsg += "process " + ptxPrcIdx + " ... ";
	vclLog.fvoWriteToAll_nl( vtxMsg );
	vinPrcNum = finStringToInt( ptxPrcIdx );

	if ( vinPrcNum == 0 && ptxPrcIdx != "0" ) 
	{
		// try locating the process assuming the argument is an alias

		vinPrcNum = vclPrcList.finFindPrcIdxByAlias( ptxPrcIdx );
		if ( vinPrcNum < 0 )
		{
			vtxMsg = "Invalid process number or name: " + ptxPrcIdx;
			goto locReturnError;
		}
	}

	vinCommand = pinCommand;
//	vinCommand = vinCommand | vinPrcNum;
	vinPrcNum = vinPrcNum + 128;

	if ( !vclService.fboControlService( vinCommand ) )
	{
		vtxMsg = "The command failed - see log entry for details.";
		goto locReturnError;
	}

	if ( !vclService.fboControlService( vinPrcNum ) )
	{
		vtxMsg = "The command failed - see log entry for details.";
		goto locReturnError;
	}

	vtxMsg = "The command was issued - see log entry to see if it succeeded.";
   vclLog.fvoWriteToAll_nl( vtxMsg );
	// vclLog.fvoWriteConsole_nl( vtxMsg );
	return true;

	locReturnError:
		if ( !vtxMsg.empty( ) )
		{
			vclLog.fvoWriteToAll_nl( vtxMsg );
		}
		return false;

} // fboExecPrcCommand

int main( int argc, char *argv[ ] )
{
	DWORD vinLastError;
	string vtxMsg;
	string vtxArg[ 3 ];
	int vinCommand;

	vclService.fvoSetLoaderPath( );
	vclLog.fvoSetFileName( vclService.vtxLoaderPath + ctxLogFileName );
	vclIni.fvoSetFileName( vclService.vtxLoaderPath + ctxIniFileName );
	vclService.fvoSetServiceName( );
	
	vclLog.fvoWriteToConsole_nl( "###");
	vclLog.fvoWriteToConsole_nl( "### (mEAn) Server Loader version " + ctxVersion );
	vclLog.fvoWriteToConsole_nl( "### copyright (c) 2003-2005 BotMeister");
	vclLog.fvoWriteToConsole_nl( "###");

	if ( argc > 3 )
	{
		vclLog.fvoWriteToConsole_nl( "Too many command options.");
		fvoDisplayUsage( );
		goto locReturnFailure;
	}
	
	for ( int vinArg = 0; vinArg < argc; vinArg++ )
	{
		vtxArg[ vinArg ] = ftxToLower( argv[ vinArg ] );
	}
		
//	if( argc == 2 && stricmp( "-remove", argv[ 1 ] ) == 0 )
	if( argc == 2 )
	{

		if ( vtxArg[ 1 ] == ctxCommand_SrvRemove ) 
		{
		
			vclLog.fvoWriteToAll_nl( "Attempting to remove service " + vclService.ftxGetServiceName( ) + " ....");

			if ( !vclService.fboRemoveService( ) )
			{
				goto locReturnFailure;
			}
			goto locReturnSuccess;
		}
	
		if ( vtxArg[ 1 ] == ctxCommand_SrvInstall )
		{	
			vclLog.fvoWriteToConsole_nl( );
			vclLog.fvoWriteToAll_nl( "Attempting to install the service ...");
			vclLog.fvoWriteToFile_nl( "Version is " + ctxVersion );
			vclService.vboUserInterface = vclIni.fboGetUserInterface( );
			if ( !vclService.fboInstallService( ) )
			{
				goto locReturnFailure;
			}
			goto locReturnSuccess;
		}

		if( vtxArg[ 1 ] == ctxCommand_SrvStart )
		{	
			vclLog.fvoWriteToAll_nl( "Attempting to start the service ...");
			if ( !vclService.finStartService( ) )
			{
				goto locReturnFailure;
			}
			goto locReturnSuccess;
		}

		if( vtxArg[ 1 ] == ctxCommand_SrvStop )
		{	
			vclLog.fvoWriteToAll_nl( "Attempting to stop the service ...");
			if ( !vclService.finStopService( ) )
			{
				goto locReturnFailure;
			}
			goto locReturnSuccess;
		}

		if( vtxArg[ 1 ] == ctxCommand_SrvPause )
		{	
			vclLog.fvoWriteToAll_nl( "Attempting to pause the service ...");
			if ( !vclService.fboPauseService( ) )
			{
				vtxMsg = "The service could not be paused.";
				goto locReturnFailure;
			}
			vtxMsg = "The command was issued - see log entry to see if it succeeded.";
			goto locReturnSuccess;
		}

		if( vtxArg[ 1 ] == ctxCommand_SrvResume )
		{	
			vclLog.fvoWriteToAll_nl( "Attempting to resume the service ...");
			if ( !vclService.fboResumeService( ) )
			{
				vtxMsg =  "The service could not be resumed.";
				goto locReturnFailure;
			}
			vtxMsg = "The command was issued - see log entry to see if it succeeded.";
			goto locReturnSuccess;
		}

		vclLog.fvoWriteToAll_nl( "Invalid command option.");
		fvoDisplayUsage( );
		goto locReturnFailure;

	}

	if ( argc == 3 )
	{	
		if ( vtxArg[ 1 ] == ctxCommand_SrvStop )
			vinCommand = cinCommand_PrcStop;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvStart )
			vinCommand = cinCommand_PrcStart;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvPause )
			vinCommand = cinCommand_PrcPause;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvResume )
			vinCommand = cinCommand_PrcResume;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvHide )
			vinCommand = cinCommand_PrcHide;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvShow )
			vinCommand = cinCommand_PrcShow;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvSetP_rt )
			vinCommand = cinCommand_PrcSetP_rt;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvSetP_hi )
			vinCommand = cinCommand_PrcSetP_hi;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvSetP_an )
			vinCommand = cinCommand_PrcSetP_an;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvSetP_no )
			vinCommand = cinCommand_PrcSetP_no;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvSetP_bn )
			vinCommand = cinCommand_PrcSetP_bn;
		else
		if ( vtxArg[ 1 ] == ctxCommand_SrvSetP_lo )
			vinCommand = cinCommand_PrcSetP_lo;
		else
		{
			vclLog.fvoWriteToAll_nl( "Invalid command option.");
			fvoDisplayUsage( );
			goto locReturnFailure;
		}
			
		if ( fboExecPrcCommand( vinCommand, vtxArg[ 2 ] ) )
			goto locReturnSuccess;

		goto locReturnFailure;

	}
	
	if ( !StartServiceCtrlDispatcher( vstGLOBAL_DispatchTable ) )
	{
		vinLastError = GetLastError( );
		if ( vinLastError == 1063 )
		{
			fvoDisplayUsage( );
		}
		else
		{
			vtxMsg = "Error (" + ftxLongToString( vinLastError ) +"): The services event dispatcher could not be started.";
		}
		goto locReturnFailure;
	}	

locReturnSuccess:
	if ( !vtxMsg.empty( ) )
		vclLog.fvoWriteToAll_nl( vtxMsg );

	return 0;

locReturnFailure:
	if ( !vtxMsg.empty( ) )
		vclLog.fvoWriteToAll_nl( vtxMsg );

	return -1;

} // main
